 
/* Bezier Spline basis calulations
   for 4 point Bezier Curves       */

import java.awt.*;

public class Bezier {
	
	private Point[] points;
	private static final int CIRCLE_WIDTH = 4;

        public  Bezier(Point[] points ){
		this.points = points; 	}

        Font currentFont ;        
    void updayteG(int xplus, int yplus){
    	points[1].x -= xplus ;
    	points[1].y += yplus ;        
    }    
    void updayteH(int yplus){
    	points[2].y += yplus ;
    }
	void paint(Graphics g, int ft, boolean dl){
            Rectangle rect  = g.getClipBounds();
	    int height = rect.height ;
            currentFont = new Font("Arial",
                                Font.PLAIN,14);
            g.setFont(currentFont);
              int jXpt = 0;
              int jYpt = 0;
              int vXpt = 0;
              int vYpt = 0,
              numbspace = 0 ;
     //     boolean drawornot = dl ;    
	 // Draw the control points
if(dl ){
              g.setColor(new Color(0, 0, 0)); // was red
	      int ijp = ft ;
	  for(int i = 0 ; i < 4; i++){ 
 g.drawOval(points[i].x, (height - points[i].y), 
 		CIRCLE_WIDTH, CIRCLE_WIDTH);
        String sn = Integer.toString(i+ijp); 
if(((i+ijp)%2)==1 ){  // number is odd
       numbspace = 10 ;     }else{
       numbspace =  0 ; }
g.drawString(sn, points[i].x-numbspace, (height - points[i].y));  }
	   
   // Draw the lines for the control points
	      g.setColor(new Color(200, 200, 200));
	      g.drawLine(points[0].x, (height - points[0].y), 
	      		points[1].x, (height - points[1].y));
	      g.drawLine(points[1].x, (height - points[1].y), 
	      		points[2].x, (height - points[2].y));
	      g.drawLine(points[2].x, (height - points[2].y), 
	      		points[3].x, (height - points[3].y));
}  // if(dl)
   // Draw the curves

             g.setColor(new Color(0, 0, 0));

              for(double incr = 0; incr <= 1.02; incr += 0.02){

            // Find the X coordinate using the
            // Bezier functions

          jXpt = (int)   ((bezpwr1(incr) * points[0].x)

                        + (bezpwr2(incr) * points[1].x)

                        + (bezpwr3(incr) * points[2].x)

                        + (bezpwr4(incr) * points[3].x));

                  // Find the Y coordinate, using the 
                  // Bezier functions

          jYpt = (int)   ((bezpwr1(incr) * points[0].y)

                        + (bezpwr2(incr) * points[1].y)

                        + (bezpwr3(incr) * points[2].y)

                        + (bezpwr4(incr) * points[3].y));

            if(incr != 0){
  // drawLine is used because Java does not have
  // a pixel drawing function

             g.drawLine(vXpt, (height -vYpt), jXpt, (height -jYpt));
                  }  // if(incr != 0 

                  vXpt = jXpt;
                  vYpt = jYpt;
	      }  // for(double t = 0  

               jXpt = 0;
               jYpt = 0;
               vXpt = 0;
               vYpt = 0;                              	      	  
        }  //paint() function

          double bezpwr1(double incr){

              return Math.pow((1.0 - incr), 3);  }

          double bezpwr2(double incr){
                         
              return (3.0 * incr * Math.pow((1.0 - incr), 2));  }

          double bezpwr3(double incr){

              return (3.0 * Math.pow(incr, 2) * (1.0 - incr));  }

          double bezpwr4(double incr){
              return Math.pow(incr, 3);  }
}   // E.O.P.
