
// FCurve5.java 2011, 2019

/*
   Draws a series of 2 Bezier curves with a 
   frame counter 0 to 45 frames of a 
   side view of an open water wave
/**
 * @author William Redelmeier
 */
// package  com.bestwaveslive            ;
import java.awt.*;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class FCurve5 extends Frame {
	//      public static boolean appletflag = true ;
	protected SliderPanel sp;

	public JSlider sliderst; // could be an array ;

	public JSlider sliderend;
	
	public Container container ;
	
	public JRadioButton rButton ;
	public JRadioButton rbdrawlines ;
	public JRadioButton rbnotdraw ;	
	protected WavePanel dp;

	boolean ok = true; // flags for sliders

	boolean mStopRequest = false;

	boolean runonce = true; // !
	
	public boolean dl ; // draw lines or not

	final double rndup = 0.55;

	int ischanged = 1;

	int incrflag = 1;

	int ipArea = 0;

	int lmw = 0; //left most wave

	int nwaves = 4;

	public static int width;

	public static int height;

        public Wave waves[] = new Wave[nwaves];

	Bezier2 wb; // [] = new Bezier2[4] ;

	boolean firsttime = true;

	boolean fpp = false; // first past the post

	// wwindex is the wave that the sliders change
	int wwindex = 1;

	int pos1, pos2, pos3, pos4;

	public FCurve5(int width, int height) {
	}

	public FCurve5() {
	}

	public static void main(String[] args) {
      
		width = 600; // = mode.getWidth(); // 600
		height = 400; // = mode.getHeight();
		// }
        FCurve5 bez = new FCurve5(width, height);

		bez.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				System.exit(0);
			}
		});
		bez.init();
          
		bez.setSize(width, height); //, 600,400);
		bez.setResizable(false);
		bez.setTitle("FCurve5.java Demo");
		bez.setVisible(true);
	} // main()

	public void init() {
		width = 600;
		height = 400;
		//        }
		this.setSize(width, height);
		this.setBackground(Color.white);
		this.setLayout(new BorderLayout());
		SliderPanel sp = new SliderPanel();
		sp.setSize(width, (int) (.25 * height));//600,50);
		this.add(sp, BorderLayout.SOUTH);
		sp.setVisible(true);
		int sval = sliderst.getValue();
		int eval = sliderend.getValue();

		for (int i = 0; i < waves.length; i++) {
           waves[i] = new Wave(width, height - 100, sval, eval);
		}
		//    transform();
		dp = new WavePanel(waves);
		pos1 = (int) (width * 0.28);
		pos2 = (int) (width * 0.33);
		pos3 = (int) (width * 0.42);
		pos4 = (int) (width * 0.45);
		dp.setSize(width, (int) (height * .75));
		this.add(dp, BorderLayout.CENTER);
		dp.setVisible(true);
	} // end of init()

	class WavePanel extends Panel {
		private Image mOffScreenImage;

		private int mWidth = -1;

		private int mHeight = -1;
		private volatile int j = 0 ;
	//	public int getj();
                public WavePanel(Wave[] pwaves){
		
	//	public int getj(){
	//	return(j++);
	//		 }
		}

		public void paint(Graphics g) {
 		//	WavePanel dp  ;
			int sval, endval;
			int wvl = waves.length;
			int dummy = lmw; // wwindex - 1 ; // was +1
			if (dummy == -1) {
				dummy = wvl;
			}
		
			 

			for (int i = 0 ; i < (wvl - 1); i++, dummy++) {
				//  checks for first series of waves
				if ((i == wwindex) && firsttime) {
					break;
				} // if
				if (dummy >= wvl) {
					dummy = 0;
				}
				if (i == (wvl - 2)) {
					firsttime = false;
				} // if
				//  checks next wave to draw
				if ((waves[dummy].pts[0].x > pos1) && // 170
                                (waves[dummy].pts[0].x < pos2)) { // 200
					fpp = true;
				}

				if ( // (firsttime == true ) &&
				(waves[dummy].pts[0].x > pos3) && // 250
                                (waves[dummy].pts[0].x < pos4) && // 270
                              fpp == true) {
					fpp = false;
                    if (ischanged == 1 && (firsttime == true)) {
                       sval = sliderst.getValue();
                  waves[wwindex].BWstart = waves[wwindex]
                               .BWstcalc(sliderst.getValue());
					}
               if (incrflag == 1 && (firsttime == true)) {
                          endval = sliderst.getValue();
                    waves[wwindex].endval = sliderend.getValue();
					}

					/*
                  * int eval = sliderend.getValue() ;
                  * waves[wwindex] = new
                  * Wave(width, height-100,sval, eval );
					 */
					wwindex++;
					if (wwindex >= wvl) {
						wwindex = 0;
					} // if
				} //  if

				// checks for end of rotation
           if ( //  ( firsttime == false ) &&
                   (waves[dummy].phaserads > waves[dummy].phaseend)) {
                   sval = sliderst.getValue();
                   endval = sliderend.getValue();
                   waves[dummy] = new Wave(width, height - 100,
                                         sval, endval);
                   waves[dummy].phaserads = 
                              waves[dummy].phaseincr * -1.0;
                          waves[dummy].lrMotAcc = 0;
                               //(int)(-1.0 * waves[dummy].lrMot
						// );
                    waves[dummy].BW = 4;
                    waves[dummy].hWvLen = 
                       (int) (0.225 * waves[dummy].getwdth());
                       waves[dummy].startval = sliderst.getValue();
                       waves[dummy].endval = sliderend.getValue();
                          lmw++;
                   if (lmw >= wvl) {
                                   lmw = 0;
                              }
                           incrflag = 0;
                            ischanged = 0;

                    //  getwdth s/b in FCurve5, magic number 250
				}//  if
                       waves[dummy].phaserads += waves[dummy].phaseincr;
                       waves[dummy].lrMotAcc += waves[dummy].lrMot;
                       reset(waves[dummy]);
                       BWreset(waves[dummy]);
                       Bezier2 wb = rotate(waves[dummy].phaserads, 
                                  waves[dummy]);
			j = waves[dummy].getj();        
		  	String Sindex = new String(Integer.toString(j));
		     	g.drawString("j = "+ Sindex, 250,20 );
		
			wb.paint(g);
			} // for
	

		} // paint( )

		//      Gets initial value of point 5 from slider

                int BWstcalc(int startval, Wave wv) {
        //      System.out.println("1 startval is " + startval);
			int ichange, retval;
			ichange = startval;
			ichange -= 3; // -3 to +3
			ichange *= wv.getwdth();
         //      System.out.println("2 startval is " + startval);
          ichange /= wv.ihorizscr;
         //      System.out.println("2 ichange is " + ichange);
			retval = (int) (0.303 * wv.getwdth()); // ?
			retval += ichange;
			return (retval);
		} // BWstcalc( )

                int calcArea(Wave wv) {
			int xbase, yheight;
			double adjy = 0, hght = 0, degangle;
			int wArea = 0;
         //      Calculate area of triangle 1/2 base * height
          xbase = (int) ((wv.pts[1].x + wv.pts[5].x) / 2 + .5);
			xbase -= wv.pts[0].x;
			xbase /= 2;
			degangle = (1.57 - wv.phaserads);
			hght = Math.sin(degangle); // in radians
			hght *= (wv.pts[3].y - wv.pts[0].y);
			hght += 0.5;
			//      if 5 lower than 3,4 - larger area
			if (wv.pts[4].y < (wv.pts[3].y - 10)) {
                 adjy = (wv.pts[3].y - wv.pts[4].y) * 0.8; // Empirical
			} //  if
			//      if 5 higher than 3,4 - smaller area
			if (wv.pts[4].y > (wv.pts[3].y)) {
                adjy = -1.0 * ((wv.pts[4].y - wv.pts[3].y) * 0.5);
				// 0.6
			} // if
			yheight = (int) (hght) + (int) adjy; // - ilev
			wArea = xbase * yheight;
			return wArea;
		} // end of calcArea

                void reset(Wave wv) {
			wv.pts = new Point[6];
			double xwd, yht;
			// System.out.println("In reset, startval is " +
			// 		wv.startval);
			wv.BWincr = BWincrSet(wv.endval);

			xwd = (double) wv.getwdth(); //wdth ;
			yht = (double) wv.gethght(); //hght ;
			//       proportional to the monitor's size
                        //  was yht + 0.11
			wv.pts[0] = new Point((int) (xwd * 0.0),
                                        (int) (yht * 0.45));  // 0.56
			wv.pts[1] = new Point((int) (xwd * 0.225), 
                                        (int) (yht * 0.45));  // 0.56
                        wv.pts[2] = new Point((int) (xwd * 0.21), // 0.17 
                                        (int) (yht * 0.72));  // 0.83
			wv.pts[3] = new Point((int) (xwd * 0.225), 
                                        (int) (yht * 0.72));  // 0.83
                        wv.BWstart += 0.12  ;
                        wv.pts[4] = new Point(wv.BWstart, 
                                        (int) (yht * 0.72)); // 0.83
			wv.pts[5] = new Point((int) (xwd * 0.45), 
                                        (int) (yht * 0.45)); // 0.56
		} //end of reset function

                Bezier2 rotate(double alpha, Wave wv) { //, Point[] pts){
			double dx2, dy2;
			double hyp, rad;
			int x1, y1;
			int lrmot = 3; // new - l to r motion
			//        Point[] gpts = new Point[4];
			//        Point[] hpts = new Point[4];
			x1 = wv.pts[1].x;
			y1 = wv.pts[1].y;
			//  Loop goes in here
			for (int i = 2; i < 5; i++) {
				dx2 = wv.pts[i].x - x1;
				dy2 = wv.pts[i].y - y1;
              hyp = Math.sqrt(dx2 * dx2 + dy2 * dy2) + rndup;
				rad = Math.atan2(dy2, dx2);
				rad = rad - alpha;

				dx2 = hyp * Math.cos(rad) + rndup;
				dy2 = hyp * Math.sin(rad) + rndup;

				wv.pts[i].x = (int) (dx2 + rndup);
				wv.pts[i].x += x1;
				wv.pts[i].y = (int) (dy2 + rndup);
				wv.pts[i].y += y1;
			} // for loop ends here
			WaveLenSet(wv);
			//  Clipping pts[4]
			int cliplev = (int) (height * .56);
			if (wv.pts[4].y <= cliplev) {
				double m = 1;
				// if line is vertical
				// if(wv.pts[2].x == wv.pts[4].x ){
				// wv.pts[4].y = cliplev ;
				// }else{
				m = (wv.pts[3].y - wv.pts[2].y);
				m /= (wv.pts[3].x - wv.pts[2].x);
           wv.pts[4].x += (int) ((cliplev - wv.pts[4].y) / m);
				wv.pts[4].y = cliplev;
			} // if
			// Collar on 5, could also clip
			// substitute pts[3] for pts[2], below
                        if (wv.pts[4].y > wv.pts[2].y) {
				wv.pts[4].y = wv.pts[2].y;
				wv.pts[4].x = wv.pts[2].x;
			} // if
        		ipArea = calcArea(wv);
			int dummyArea = ipArea;
			int g1x, g1y, h2x, h2y;
			g1x = wv.pts[1].x;
			g1y = wv.pts[1].y;
			h2x = wv.pts[1].x;
			h2y = wv.pts[1].y;
			// int puffsearly = 7800 ;
			// int puffslate = 7500 ;
			int krs = 4;
			// puffs up more
                        while (dummyArea < 7000) { // was 7500,8000
				g1x -= 7;
				g1y += 2;
				h2x += krs;
				h2y += 7;
				dummyArea += 600;
                                if (dummyArea > 1200) {  //was 1200
					krs = 1;
				} // if
			}// while The above can be optimized, but...
			//  Add lrmot to all points' x value
			//  for motion from left to right
			wv.pts[0].x += wv.lrMotAcc;
			wv.pts[2].x += wv.lrMotAcc;
			wv.pts[3].x += wv.lrMotAcc;
			wv.pts[4].x += wv.lrMotAcc;
			wv.pts[5].x += wv.lrMotAcc;
			g1x += wv.lrMotAcc;
			h2x += wv.lrMotAcc;

			wv.gpts[0] = wv.pts[0];
			wv.gpts[1] = new Point(g1x, g1y);
			wv.gpts[2] = wv.pts[2];
			wv.gpts[3] = wv.pts[3];

			wv.hpts[0] = wv.pts[3]; //4
			wv.hpts[1] = wv.pts[4]; //5
			wv.hpts[2] = new Point(h2x, h2y);
			wv.hpts[3] = wv.pts[5];

      //                bezierG = new Bezier(gpts);
      //                bezierH = new Bezier(hpts);
			return new Bezier2(new Bezier(wv.gpts), 
                   new Bezier(wv.hpts), dl );
		} // rotate

                void BWreset(Wave wave) {
			wave.BW += wave.BWincr;
         wave.pts[4].x += wave.BW; // number 5 point changing
         if (wave.hWvLen > (int) (0.15 * wave.getwdth())) {
				wave.hWvLen *= -1;
			} // if
			// wavelength shrinking
		} // BWreset

		int BWincrSet(int endval) {
          waves[wwindex].BWincr = (waves[wwindex].endval - 5);
         return waves[wwindex].BWincr;
		} // BWincrSet()

		void WaveLenSet(Wave wave) { // called in rotate()
			int xLe = 0, xRe = 0;
			//	   hWvLen = (int)(0.225*getwdth()) ;
			int xmid = (int) (wave.getwdth() * 0.225);
			xLe = (int) (xmid - wave.hWvLen);
			xRe = (int) (xmid + wave.hWvLen);
			wave.pts[0].x = xLe;
			wave.pts[5].x = xRe;
		} // WaveLenSet

	} //  WavePanel

	class SliderPanel extends JPanel {

		class AListener implements ActionListener {

			public void actionPerformed(ActionEvent e) {
				if (ok) {

					//  Starts
                        if (!mStopRequest && runonce) {
                            new WaveAnimator().start();

					} else {
						//  
                            if (mStopRequest == false) {
                                mStopRequest = true;
                                    runonce = true;
						}
					}//else
                       // System.out.println("mStopRequest "+ 
					//mStopRequest);
				}// if(ok)
			} // actionPerformed

			class WaveAnimator extends Thread {
				private WaveAnimator WA;

   //               final double dMoveInterval = .05 ; //seconds
                final int mDrawInterval = 200;// milliseconds

				public void run() {
					int j = 0 ;
					runonce = false;
					while (!mStopRequest) {
						dp.repaint(j);
					//	j++ ;
						try {
                           //transform()
                          // moveWaves()
                               Thread.sleep(mDrawInterval);
                        } catch (InterruptedException xpt) {
						}
					} // while(
					mStopRequest = false;
				} // run
			} // WaveAnimator

		

		} // WavePAnel

		class SliderListener implements ChangeListener {
			public void stateChanged(ChangeEvent e) {

				if (e.getSource() == sliderst) {
					ischanged = 1;
       //  com.bestwaveslive.wave.startval = sliderst.getValue();

				} // if
				if (e.getSource() == sliderend) {
					incrflag = 1;
       //  com.bestwaveslive.wave.endval = sliderend.getValue();
				} // if
			} // stateChanged
		} // SliderListener

		 class CustomListener implements ActionListener{
            public void actionPerformed(ActionEvent evt){            	
            	
           rButton =	(JRadioButton)evt.getSource();
            if(rButton == rbdrawlines ){
             	dl = true ;
            }
			if(rButton == rbnotdraw ){
	             	dl = false  ;	        		    
	             }	                                   
            }
            }		
		SliderPanel() {

			GridBagLayout gridbag = new GridBagLayout();
			setLayout(gridbag);
			GridBagConstraints c = new GridBagConstraints();
			c.fill = GridBagConstraints.BOTH;
			c.insets = new Insets(5, 5, 5, 5);
             
			
			
			JButton b_disclaimer = new JButton("ABOUT");
			c.gridx = 0;
			c.gridy = 0;
			c.gridwidth = 2;
			c.gridheight = 1;
			gridbag.setConstraints(b_disclaimer, c);
			add(b_disclaimer);
			b_disclaimer.addActionListener(new AListener());
			
			JButton b_anim = new JButton("Go/Stop");
			c.gridx = 3;
			c.gridy = 0;
			c.gridwidth = GridBagConstraints.REMAINDER;
			c.gridheight = 1;
			c.weightx = 1.0;
			c.weighty = 1.0;
			gridbag.setConstraints(b_anim, c);
			add(b_anim);
			b_anim.addActionListener(new AListener());

        b_disclaimer.addActionListener(new ActionListener() {

          public void actionPerformed(ActionEvent e) {
        //   JOptionPane.showMessageDialog(null, strung );
             String choices[] = // new String[2];choices[] =
              { "Accept", "Reject" };
            String licenseLabel = "About Box";
 String license = "FCurve5.java Copyright (c) 2008-2010, 2018 William Redelmeier\n"+
                             
     "Animates an open water breaking wave in 2 dimensions, Left to right. \n "+
     "with a frame counter.  The sliders don't work. Based on \n "+
     "WaveBezier.java and related files:Wave.java,Bezier.java,Bezier2.java \n "+
     "It uses JRE version 1.8.0_191-b12 for a 64 bit computer with  \n "+
     "Java HotSpot(TM) 64 bit Server VM (build 25.191-b12, mixed mode)  \n "+
     "Microsoft Windows [Version 6.1.7601]  \n "+
     "FCurves.java has not been tested as an applet...  \n "+	
     "Java and Oracle are trademarks of Oracle Corporation. \n "+	
     "William's e-mail is wredelm@rogers.com \n "+
     "The author is not the owner of Southbrook Wineries  \n "+	
     "This program is free software: you can redistribute it and/or \n "+
     "modify it under the terms of the GNU General Public License \n "+
     "as published by the Free Software Foundation, either version \n "+
     "3 of the License, or (at your option) any later version. \n "+
     "This program is distributed in the hope that it will be useful,\n "+ 
     "but WITHOUT ANY WARRANTY; without even the implied warranty of \n "+
     "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See \n "+
     "the GNU General Public License for more details. \n "+
     "You should have received a copy of the GNU General Public\n "+ 
     " License along with this program. If not,\n "+
     " see <http://www.gnu.org/licenses/>. \n "+
     "Linking this library statically or dynamically with other\n "+ 
     "modules is making a combined work based on this library. \n "+
     "Thus, the terms and conditions of the GNU General Public License\n "+ 
     "cover the whole combination. \n "+

     "As a special exception, the copyright holders of this\n "+
     "library give you permission to link this library with \n "+
     "independent modules to produce an executable, regardless \n "+
     "of the license terms of these independent modules, \n "+
     "and to copy and distribute the resulting executable under\n "+ 
     "terms of your choice, provided that you also meet, \n "+
     "for each linked independent module, the terms and conditions\n "+ 
     "of the license of that module. An independent module is \n "+
     "a module which is not derived from or based on this library. \n "+
     "If you modify this library, you may extend this exception to \n "+
     "your version of the library, but you are not obligated to \n "+
     "do so. If you do not wish to do so, delete this exception \n "+
     "statement from your version. \n "+ 
     "You acknowledge that the Software is not designed,\n"+
     "licensed or intended for use in the design, construction, \n"+
     "operation or maintenance of any nuclear facility. \n";

            JScrollPane sp = new JScrollPane(
                   new JTextArea(license, 6, 40));
              Object msgs[] = new Object[] { licenseLabel, sp };
              int returnValue2 = JOptionPane.CLOSED_OPTION;

                while (returnValue2 != 0) { // or try scroll, below
               returnValue2 = JOptionPane.showOptionDialog(dp, 
                             msgs, "About", 
                           JOptionPane.OK_CANCEL_OPTION,
                           JOptionPane.QUESTION_MESSAGE, 
                                null, choices,
                                 choices[1]);

                       if (returnValue2 == 1) { // rejection
                               mStopRequest = true;
                             ok = false;
                //        if(appletflag == true ){
             //                stop(); }
                             System.exit(0);
						}
					}
				}
			}// while(r
					); 
		//	.addAction

			// Put in private classes of sliders
            JLabel lFiveStart = new JLabel("CONCAVITY OF WAVE");
            JLabel lFiveEnd = new JLabel("CONCAVITY OF WAVE");

			c.gridx = 0;
			c.gridy = 1;
			c.gridwidth = 2;
			c.gridheight = 1;
			c.weightx = 1.0;
			c.weighty = 1.0;
			gridbag.setConstraints(lFiveStart, c);
			add(lFiveStart);
			c.gridx = 3;
			c.gridy = 1;
			c.gridwidth = GridBagConstraints.REMAINDER;
               sliderst = new JSlider(JSlider.HORIZONTAL, 0, 6, 3);
			gridbag.setConstraints(sliderst, c);
		//	add(sliderst);
			sliderst.addChangeListener(new SliderListener());

			c.weightx = 1.0;
			c.weighty = 1.0;
			c.gridx = 0;
			c.gridy = 2;
			c.gridwidth = 2;
			c.gridheight = 1;
			c.weightx = 1.0;
			c.weighty = 1.0;
			gridbag.setConstraints(lFiveEnd, c);
			add(lFiveEnd);
			c.gridx = 3;
			c.gridy = 2;
			c.gridwidth = GridBagConstraints.REMAINDER;
              sliderend = new JSlider(JSlider.HORIZONTAL, 0, 10, 5);
			gridbag.setConstraints(sliderend, c);
		//	add(sliderend);
			sliderend.addChangeListener(new SliderListener());

               rbdrawlines = new JRadioButton("with lines",false);
               rbdrawlines.addActionListener(new CustomListener()) ;
               rbnotdraw   = new JRadioButton("without lines", true);
               rbnotdraw.addActionListener(new CustomListener()) ;
		    ButtonGroup group = new ButtonGroup();
		    group.add(rbdrawlines);
            group.add(rbnotdraw);
            c.gridx = 0;
			c.gridy = 3;
			c.gridwidth = 2;
			c.gridheight = 1;
			c.weightx = 1.0;
			c.weighty = 1.0;
			gridbag.setConstraints(rbdrawlines, c);
			add(rbdrawlines);
			c.gridx = 3;
			c.gridy = 3;
			c.gridwidth = GridBagConstraints.REMAINDER;
		
			gridbag.setConstraints(rbnotdraw, c);
			add(rbnotdraw);																		
			
		}// SliderPanel
	} // JPanel
 }  // E.O.P 
