
/**
 * Wave.java  Does preliminary math for breaking wave control points.
 * 
 * @author William Redelmeier
 */
 /*     Created in 2007, 2008
 * 
 *                     2*      3*       *4 
 *                        ____ /|\ 
 *                  _____/      |  \ 
 *            _____/            |    \ 
 *      _____/                  |      \ 
 *  ___/                        |         \
 * /____________________________|___________\
 * 0*                          1*           5*
 * 
 * Bezier Control points, 2 sets At the start, before rotation.
 * Curve not depicted.
 * 
 *                            2*
 * 
 *                                   3*   
 *                                ___/\ 
 *                        _ _____/   |  \       *4
 *                _______/          |    \ 
 *          _____/                 |      \
 *  _______/                     |         \
 * /____________________________|___________\
 *0*                           1*           5*
 * 
 * Bezier Control points, 2 sets At the start, after rotation Curve not depicted
 */

import java.awt.Point;

public class Wave {

	protected double xwd = 0.0, yht = 0.0;
	public int ihorizscr = 40;
	double phaseincr = .029;// increase of angle was .08

	public double phaserads = 1.601;

	//alphincr * -1.0; // Angle 1.601

	double phaseend = 1.35; // greatest possible angle 1.41

	//  in radian measure, 0 is vertical - resets to it

        int BW = 10; // was 4; //   Bulk width in pixels

        int BWincr = 3; //was 4; // decrease of BW - wave shoulder

	volatile int BWstart; // = 0 ;

	int hWvLen = 0;

	int BWend = 0;

	int startval; //= sliderst.getValue();

	int endval; // from sliders 3,5

        Bezier  bezierG, bezierH;

	Point[] pts;

	int ilev1; // base, lev2 is starting height

	static int wdth, hght; // 600,400

	Point[] gpts = new Point[4];

	Point[] hpts = new Point[4];

	int lrMotAcc = 0;

	int lrMot = 7; // = 8 ;

	int j = 0 ; 

	void setwdth(int wdth) {
		Wave.wdth = wdth;
		// System.out.println("In Wave, wdth is "+wdth);
		//  600
	}

	void sethght(int hght) {
		Wave.hght = hght;
		// (int)(lev2 - lev1)
	}

	int gethght() {
		//  return(pts[5].x - (int)(lev1));
		//  probably should be

		return (hght);
	}

	int getwdth() {
		return (Wave.wdth);
	}

	public Point[] getPts() {
		return pts;
	}

	public int getj(){

		return j++ ;
	}
	public Wave(int w, int h, int startval, int endval) {
		this.setwdth(w);
		this.sethght(h);
		pts = new Point[6];
		//	double xwd, yht ;
		xwd = (double) wdth; // was w
		yht = (double) hght; // was h
		BWstart = BWstcalc(startval); //(int)(.503 * xwd);
		//		numframes = (int) (alphend / alphincr);
		// 	   System.out.println("xwd is " + xwd);
		//	   System.out.println("yht is " + yht);

		double lev1 = (yht * 0.26); //  was .46
		double lev2 = (yht * 0.63); //  was .73
		ilev1 = (int) (lev1);
		int ilev2 = (int) (lev2);
		// System.out.println("ilev2 is " + ilev2); // 46

                bezierG = new Bezier(gpts);
                bezierH = new Bezier(hpts);

		phaseincr = .032;// increase of angle was .08

		phaserads = 1.601;
		// alphincr * -1.0; // Angle 1.601

		phaseend = 1.38; // greatest possible angle
		//  in radian measure, 0 is vertical - resets to it

		BW = 4; //   Bulk width in pixels

		BWincr = 4; // decrease of BW - wave shoulder

		//        BWstart = 0 ;
		//        hWvLen = 0 ;
		//        BWend = 0 ;

		pts = new Point[6];
		double xwd, yht;
    /*
     * if (incrflag == 1) { BWincr = BWincrSet(endval); incrflag = 0; }
     */
		xwd = (double) getwdth(); //wdth ;
		yht = (double) gethght(); //hght ;
		//       proportional to the monitor's size
		pts[0] = new Point((int) (xwd * 0.0),   (int) (yht * 0.56));
		pts[1] = new Point((int) (xwd * 0.225), (int) (yht * 0.56));
		pts[2] = new Point((int) (xwd * 0.17),  (int) (yht * 0.83));
		pts[3] = new Point((int) (xwd * 0.225), (int) (yht * 0.83));
		pts[4] = new Point(BWstart, (int) (yht * 0.83)); // 5
		pts[5] = new Point((int) (xwd * 0.45),  (int) (yht * 0.56));

	} //  end of Wave constructor

	// Gets initial value of point 5 from slider
	int BWstcalc(int startval) {
		//System.out.println("1 startval is " + startval);
		int ichange, retval;
		ichange = startval;
		ichange -= 3; // -3 to +3
		ichange *= getwdth();
		//System.out.println("2 startval is " + startval);
		ichange /= ihorizscr;
		//System.out.println("2 ichange is " + ichange);
		retval = (int) (0.303 * getwdth()); // ?
		retval += ichange;
		return (retval);
	}
} // E.O.P.

